##### Commands for R (R: A language and environment for statistical computing. R Foundation for Statistical Computing, Vienna, Austria) for Monte-Carlo statistics for the calculation of significance levels of the deviation of the Residuals Rij from zero.




### expected matrix
 
matexp=read.table(file.choose())
 
### observed matrix
 
matob=read.table(file.choose())
 
 
 
### total number of ants observed in the matrix
 
size<-sum(matob)
 
### number of simulations
 
simnum=1000000
 
### Randomisation
 
rc=dim(matexp)[1]*dim(matexp)[2]
x=seq(1:rc)
p=as.vector(as.matrix(matexp))
o=as.vector(as.matrix(matob))
r=dim(matexp)[1]
c=dim(matexp)[2]
 
matsim=matrix(NA,simnum,rc)
for (n in 1:simnum) {
    ziehen=sample(x, size, replace = T, prob = p)
    vektor=rep(NA,rc)
    for (n2 in 1:rc) vektor[n2]=length(ziehen[ziehen==n2])
    matsim[n,]=vektor }
 
p.values<-rep(NA,rc)
for(n in 1:rc) {
      dif<-matsim[,n]-o[n]
      sm<-length(dif[dif>0])
      la<-length(dif[dif<0])
      eq<-length(dif[dif==0])
      psm<-(sm+eq)/simnum
      pla<-(la+eq)/simnum
      pval<-ifelse(psm<pla, psm, pla)
      p.values[n]=pval }
 
pm<-matrix(p.values, nrow=r)
pm
write.table(pm, "la p.values.txt")
 
 
### calculation of variances
 
variances<-rep(NA,simnum)
for(n in 1:simnum){
      propsim<-matsim[n,]/size
      ressim<-propsim-p
      varsim<-var(ressim)
      variances[n]<-varsim }
 
varreal<-var((o/size)-p)
varreal
mean(variances)  
sd(variances)
sd(variances)/length(variances)
confint(aov(variances~1), level=0.95, trace=F)
